import{s as Ne,n as Fe,o as Ve}from"../chunks/scheduler.85c25b89.js";import{S as Oe,i as Ae,g as i,s as n,r as c,A as je,h as m,f as a,c as r,j as f,u as d,x,k as g,y as s,a as l,v as p,d as u,t as v,w as h}from"../chunks/index.c9837788.js";import{D as L}from"../chunks/Docstring.288498f9.js";import{H as _e}from"../chunks/Heading.3097d2ed.js";function Ue(Le){let $,Y,W,Z,T,ee,S,Te="This page contains the API reference documentation for learning rate schedulers included in <code>timm</code>.",ae,z,te,R,le,C,P,ne,M,H,re,k,ie,o,E,fe,j,Se=`Cosine decay with restarts.
This is described in the paper <a href="https://arxiv.org/abs/1608.03983" rel="nofollow">https://arxiv.org/abs/1608.03983</a>.`,ge,U,ze=`Inspiration from
<a href="https://github.com/allenai/allennlp/blob/master/allennlp/training/learning_rate_schedulers/cosine.py" rel="nofollow">https://github.com/allenai/allennlp/blob/master/allennlp/training/learning_rate_schedulers/cosine.py</a>`,$e,q,Re='k-decay option based on <code>k-decay: A New Method For Learning Rate Schedule</code> - <a href="https://arxiv.org/abs/2004.05909" rel="nofollow">https://arxiv.org/abs/2004.05909</a>',me,D,I,se,b,N,be,B,Ce="Decay the LR by a factor every time the validation loss plateaus.",oe,_,F,ye,G,Pe="Polynomial LR Scheduler w/ warmup, noise, and k-decay",we,J,Me='k-decay option based on <code>k-decay: A New Method For Learning Rate Schedule</code> - <a href="https://arxiv.org/abs/2004.05909" rel="nofollow">https://arxiv.org/abs/2004.05909</a>',ce,V,O,de,y,A,xe,K,He=`Hyberbolic-Tangent decay with restarts.
This is described in the paper <a href="https://arxiv.org/abs/1806.01593" rel="nofollow">https://arxiv.org/abs/1806.01593</a>`,pe,X,ue;return T=new _e({props:{title:"Learning Rate Schedulers",local:"learning-rate-schedulers",headingTag:"h1"}}),z=new _e({props:{title:"Schedulers",local:"schedulers",headingTag:"h2"}}),R=new _e({props:{title:"Factory functions",local:"timm.scheduler.create_scheduler",headingTag:"h3"}}),P=new L({props:{name:"timm.scheduler.create_scheduler",anchor:"timm.scheduler.create_scheduler",parameters:[{name:"args",val:""},{name:"optimizer",val:": Optimizer"},{name:"updates_per_epoch",val:": int = 0"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/scheduler/scheduler_factory.py#L48"}}),H=new L({props:{name:"timm.scheduler.create_scheduler_v2",anchor:"timm.scheduler.create_scheduler_v2",parameters:[{name:"optimizer",val:": Optimizer"},{name:"sched",val:": str = 'cosine'"},{name:"num_epochs",val:": int = 300"},{name:"decay_epochs",val:": int = 90"},{name:"decay_milestones",val:": typing.List[int] = (90, 180, 270)"},{name:"cooldown_epochs",val:": int = 0"},{name:"patience_epochs",val:": int = 10"},{name:"decay_rate",val:": float = 0.1"},{name:"min_lr",val:": float = 0"},{name:"warmup_lr",val:": float = 1e-05"},{name:"warmup_epochs",val:": int = 0"},{name:"warmup_prefix",val:": bool = False"},{name:"noise",val:": typing.Union[float, typing.List[float]] = None"},{name:"noise_pct",val:": float = 0.67"},{name:"noise_std",val:": float = 1.0"},{name:"noise_seed",val:": int = 42"},{name:"cycle_mul",val:": float = 1.0"},{name:"cycle_decay",val:": float = 0.1"},{name:"cycle_limit",val:": int = 1"},{name:"k_decay",val:": float = 1.0"},{name:"plateau_mode",val:": str = 'max'"},{name:"step_on_epochs",val:": bool = True"},{name:"updates_per_epoch",val:": int = 0"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/scheduler/scheduler_factory.py#L60"}}),k=new _e({props:{title:"Scheduler Classes",local:"timm.scheduler.CosineLRScheduler",headingTag:"h3"}}),E=new L({props:{name:"class timm.scheduler.CosineLRScheduler",anchor:"timm.scheduler.CosineLRScheduler",parameters:[{name:"optimizer",val:": Optimizer"},{name:"t_initial",val:": int"},{name:"lr_min",val:": float = 0.0"},{name:"cycle_mul",val:": float = 1.0"},{name:"cycle_decay",val:": float = 1.0"},{name:"cycle_limit",val:": int = 1"},{name:"warmup_t",val:" = 0"},{name:"warmup_lr_init",val:" = 0"},{name:"warmup_prefix",val:" = False"},{name:"t_in_epochs",val:" = True"},{name:"noise_range_t",val:" = None"},{name:"noise_pct",val:" = 0.67"},{name:"noise_std",val:" = 1.0"},{name:"noise_seed",val:" = 42"},{name:"k_decay",val:" = 1.0"},{name:"initialize",val:" = True"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/scheduler/cosine_lr.py#L18"}}),I=new L({props:{name:"class timm.scheduler.MultiStepLRScheduler",anchor:"timm.scheduler.MultiStepLRScheduler",parameters:[{name:"optimizer",val:": Optimizer"},{name:"decay_t",val:": typing.List[int]"},{name:"decay_rate",val:": float = 1.0"},{name:"warmup_t",val:" = 0"},{name:"warmup_lr_init",val:" = 0"},{name:"warmup_prefix",val:" = True"},{name:"t_in_epochs",val:" = True"},{name:"noise_range_t",val:" = None"},{name:"noise_pct",val:" = 0.67"},{name:"noise_std",val:" = 1.0"},{name:"noise_seed",val:" = 42"},{name:"initialize",val:" = True"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/scheduler/multistep_lr.py#L10"}}),N=new L({props:{name:"class timm.scheduler.PlateauLRScheduler",anchor:"timm.scheduler.PlateauLRScheduler",parameters:[{name:"optimizer",val:""},{name:"decay_rate",val:" = 0.1"},{name:"patience_t",val:" = 10"},{name:"verbose",val:" = True"},{name:"threshold",val:" = 0.0001"},{name:"cooldown_t",val:" = 0"},{name:"warmup_t",val:" = 0"},{name:"warmup_lr_init",val:" = 0"},{name:"lr_min",val:" = 0"},{name:"mode",val:" = 'max'"},{name:"noise_range_t",val:" = None"},{name:"noise_type",val:" = 'normal'"},{name:"noise_pct",val:" = 0.67"},{name:"noise_std",val:" = 1.0"},{name:"noise_seed",val:" = None"},{name:"initialize",val:" = True"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/scheduler/plateau_lr.py#L12"}}),F=new L({props:{name:"class timm.scheduler.PolyLRScheduler",anchor:"timm.scheduler.PolyLRScheduler",parameters:[{name:"optimizer",val:": Optimizer"},{name:"t_initial",val:": int"},{name:"power",val:": float = 0.5"},{name:"lr_min",val:": float = 0.0"},{name:"cycle_mul",val:": float = 1.0"},{name:"cycle_decay",val:": float = 1.0"},{name:"cycle_limit",val:": int = 1"},{name:"warmup_t",val:" = 0"},{name:"warmup_lr_init",val:" = 0"},{name:"warmup_prefix",val:" = False"},{name:"t_in_epochs",val:" = True"},{name:"noise_range_t",val:" = None"},{name:"noise_pct",val:" = 0.67"},{name:"noise_std",val:" = 1.0"},{name:"noise_seed",val:" = 42"},{name:"k_decay",val:" = 1.0"},{name:"initialize",val:" = True"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/scheduler/poly_lr.py#L18"}}),O=new L({props:{name:"class timm.scheduler.StepLRScheduler",anchor:"timm.scheduler.StepLRScheduler",parameters:[{name:"optimizer",val:": Optimizer"},{name:"decay_t",val:": float"},{name:"decay_rate",val:": float = 1.0"},{name:"warmup_t",val:" = 0"},{name:"warmup_lr_init",val:" = 0"},{name:"warmup_prefix",val:" = True"},{name:"t_in_epochs",val:" = True"},{name:"noise_range_t",val:" = None"},{name:"noise_pct",val:" = 0.67"},{name:"noise_std",val:" = 1.0"},{name:"noise_seed",val:" = 42"},{name:"initialize",val:" = True"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/scheduler/step_lr.py#L13"}}),A=new L({props:{name:"class timm.scheduler.TanhLRScheduler",anchor:"timm.scheduler.TanhLRScheduler",parameters:[{name:"optimizer",val:": Optimizer"},{name:"t_initial",val:": int"},{name:"lb",val:": float = -7.0"},{name:"ub",val:": float = 3.0"},{name:"lr_min",val:": float = 0.0"},{name:"cycle_mul",val:": float = 1.0"},{name:"cycle_decay",val:": float = 1.0"},{name:"cycle_limit",val:": int = 1"},{name:"warmup_t",val:" = 0"},{name:"warmup_lr_init",val:" = 0"},{name:"warmup_prefix",val:" = False"},{name:"t_in_epochs",val:" = True"},{name:"noise_range_t",val:" = None"},{name:"noise_pct",val:" = 0.67"},{name:"noise_std",val:" = 1.0"},{name:"noise_seed",val:" = 42"},{name:"initialize",val:" = True"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/scheduler/tanh_lr.py#L18"}}),{c(){$=i("meta"),Y=n(),W=i("p"),Z=n(),c(T.$$.fragment),ee=n(),S=i("p"),S.innerHTML=Te,ae=n(),c(z.$$.fragment),te=n(),c(R.$$.fragment),le=n(),C=i("div"),c(P.$$.fragment),ne=n(),M=i("div"),c(H.$$.fragment),re=n(),c(k.$$.fragment),ie=n(),o=i("div"),c(E.$$.fragment),fe=n(),j=i("p"),j.innerHTML=Se,ge=n(),U=i("p"),U.innerHTML=ze,$e=n(),q=i("p"),q.innerHTML=Re,me=n(),D=i("div"),c(I.$$.fragment),se=n(),b=i("div"),c(N.$$.fragment),be=n(),B=i("p"),B.textContent=Ce,oe=n(),_=i("div"),c(F.$$.fragment),ye=n(),G=i("p"),G.textContent=Pe,we=n(),J=i("p"),J.innerHTML=Me,ce=n(),V=i("div"),c(O.$$.fragment),de=n(),y=i("div"),c(A.$$.fragment),xe=n(),K=i("p"),K.innerHTML=He,pe=n(),X=i("p"),this.h()},l(e){const t=je("svelte-u9bgzb",document.head);$=m(t,"META",{name:!0,content:!0}),t.forEach(a),Y=r(e),W=m(e,"P",{}),f(W).forEach(a),Z=r(e),d(T.$$.fragment,e),ee=r(e),S=m(e,"P",{"data-svelte-h":!0}),x(S)!=="svelte-k4ut34"&&(S.innerHTML=Te),ae=r(e),d(z.$$.fragment,e),te=r(e),d(R.$$.fragment,e),le=r(e),C=m(e,"DIV",{class:!0});var ke=f(C);d(P.$$.fragment,ke),ke.forEach(a),ne=r(e),M=m(e,"DIV",{class:!0});var Ee=f(M);d(H.$$.fragment,Ee),Ee.forEach(a),re=r(e),d(k.$$.fragment,e),ie=r(e),o=m(e,"DIV",{class:!0});var w=f(o);d(E.$$.fragment,w),fe=r(w),j=m(w,"P",{"data-svelte-h":!0}),x(j)!=="svelte-142rxjd"&&(j.innerHTML=Se),ge=r(w),U=m(w,"P",{"data-svelte-h":!0}),x(U)!=="svelte-z0bxov"&&(U.innerHTML=ze),$e=r(w),q=m(w,"P",{"data-svelte-h":!0}),x(q)!=="svelte-1wsck9y"&&(q.innerHTML=Re),w.forEach(a),me=r(e),D=m(e,"DIV",{class:!0});var De=f(D);d(I.$$.fragment,De),De.forEach(a),se=r(e),b=m(e,"DIV",{class:!0});var ve=f(b);d(N.$$.fragment,ve),be=r(ve),B=m(ve,"P",{"data-svelte-h":!0}),x(B)!=="svelte-1sewxb2"&&(B.textContent=Ce),ve.forEach(a),oe=r(e),_=m(e,"DIV",{class:!0});var Q=f(_);d(F.$$.fragment,Q),ye=r(Q),G=m(Q,"P",{"data-svelte-h":!0}),x(G)!=="svelte-16f5sza"&&(G.textContent=Pe),we=r(Q),J=m(Q,"P",{"data-svelte-h":!0}),x(J)!=="svelte-1wsck9y"&&(J.innerHTML=Me),Q.forEach(a),ce=r(e),V=m(e,"DIV",{class:!0});var Ie=f(V);d(O.$$.fragment,Ie),Ie.forEach(a),de=r(e),y=m(e,"DIV",{class:!0});var he=f(y);d(A.$$.fragment,he),xe=r(he),K=m(he,"P",{"data-svelte-h":!0}),x(K)!=="svelte-1rx2bx1"&&(K.innerHTML=He),he.forEach(a),pe=r(e),X=m(e,"P",{}),f(X).forEach(a),this.h()},h(){g($,"name","hf:doc:metadata"),g($,"content",qe),g(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),g(M,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),g(o,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),g(D,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),g(b,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),g(_,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),g(V,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),g(y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,t){s(document.head,$),l(e,Y,t),l(e,W,t),l(e,Z,t),p(T,e,t),l(e,ee,t),l(e,S,t),l(e,ae,t),p(z,e,t),l(e,te,t),p(R,e,t),l(e,le,t),l(e,C,t),p(P,C,null),l(e,ne,t),l(e,M,t),p(H,M,null),l(e,re,t),p(k,e,t),l(e,ie,t),l(e,o,t),p(E,o,null),s(o,fe),s(o,j),s(o,ge),s(o,U),s(o,$e),s(o,q),l(e,me,t),l(e,D,t),p(I,D,null),l(e,se,t),l(e,b,t),p(N,b,null),s(b,be),s(b,B),l(e,oe,t),l(e,_,t),p(F,_,null),s(_,ye),s(_,G),s(_,we),s(_,J),l(e,ce,t),l(e,V,t),p(O,V,null),l(e,de,t),l(e,y,t),p(A,y,null),s(y,xe),s(y,K),l(e,pe,t),l(e,X,t),ue=!0},p:Fe,i(e){ue||(u(T.$$.fragment,e),u(z.$$.fragment,e),u(R.$$.fragment,e),u(P.$$.fragment,e),u(H.$$.fragment,e),u(k.$$.fragment,e),u(E.$$.fragment,e),u(I.$$.fragment,e),u(N.$$.fragment,e),u(F.$$.fragment,e),u(O.$$.fragment,e),u(A.$$.fragment,e),ue=!0)},o(e){v(T.$$.fragment,e),v(z.$$.fragment,e),v(R.$$.fragment,e),v(P.$$.fragment,e),v(H.$$.fragment,e),v(k.$$.fragment,e),v(E.$$.fragment,e),v(I.$$.fragment,e),v(N.$$.fragment,e),v(F.$$.fragment,e),v(O.$$.fragment,e),v(A.$$.fragment,e),ue=!1},d(e){e&&(a(Y),a(W),a(Z),a(ee),a(S),a(ae),a(te),a(le),a(C),a(ne),a(M),a(re),a(ie),a(o),a(me),a(D),a(se),a(b),a(oe),a(_),a(ce),a(V),a(de),a(y),a(pe),a(X)),a($),h(T,e),h(z,e),h(R,e),h(P),h(H),h(k,e),h(E),h(I),h(N),h(F),h(O),h(A)}}}const qe='{"title":"Learning Rate Schedulers","local":"learning-rate-schedulers","sections":[{"title":"Schedulers","local":"schedulers","sections":[{"title":"Factory functions","local":"timm.scheduler.create_scheduler","sections":[],"depth":3},{"title":"Scheduler Classes","local":"timm.scheduler.CosineLRScheduler","sections":[],"depth":3}],"depth":2}],"depth":1}';function Be(Le){return Ve(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class We extends Oe{constructor($){super(),Ae(this,$,Be,Ue,Ne,{})}}export{We as component};
